<template>
  <div class="login">
    <form novalidate class="md-layout" @submit.prevent="validateUser">
      <md-card class="md-card">
        <md-card-header>
          <md-icon>school</md-icon>
          <div class="md-title">Sign in</div>
          <div class="md-subhead">to continue to TutorBook</div>
        </md-card-header>

        <md-card-content>
          <md-field :class="getValidationClass('email')">
            <label for="email">Email</label>
            <md-input name="email" id="email" v-model="loginData.user_name" autocomplete="email" :disabled="sending"/>
            <span class="md-error" v-if="!$v.loginData.user_name.required">The email is required</span>
            <span class="md-error" v-if="!$v.loginData.user_name.email">The email is not valid</span>
          </md-field>
          <md-field :class="getValidationClass('password')" :md-toggle-password="false">
            <label for="password">Password</label>
            <md-input name="password" id="password" v-model="loginData.password" autocomplete="current-password" type="password" :disabled="sending"/>
            <span class="md-error" v-if="!$v.loginData.password.required">The password is required</span>
          </md-field>
        </md-card-content>

        <md-card-actions>
          <md-button type="submit" :disabled="sending">Login</md-button>
        </md-card-actions>
      </md-card>
    </form>

    <error-dialog-alert></error-dialog-alert>
  </div>
</template>

<script>
import {EventBus} from "@/main";
import axios from 'axios'
import { validationMixin } from 'vuelidate'
import {
  required,
  email,
} from 'vuelidate/lib/validators'
import ErrorAlert from "@/components/util/ErrorAlert";

export default {
  name: "Login",
  mixins: [validationMixin],
  components: {'error-dialog-alert': ErrorAlert},
  validations: {
    loginData: {
      user_name: {
        required,
        email
      },
      password: {
        required
      }
    }
  },
  data () {
    return {
      loginData: {
        user_name: '',
        password: ''
      },
      sending: false
    }
  },
  methods: {

    getValidationClass (fieldName) {
      const field = this.$v.loginData[fieldName];

      if (field) {
        return {
          'md-invalid': field.$invalid && field.$dirty
        }
      }
    },
    clear: function() {
      this.$v.$reset();
      this.loginData.user_name = '';
      this.loginData.password = ''
    },
    validateUser () {
      this.$v.$touch();

      if (!this.$v.$invalid) {
        this.auth()
      }
    },
    auth: function () {
      axios.post('https://jsonplaceholder.typicode.com/posts', this.loginData)
        .then(() => this.$router.push('/home'))
        .catch(() => {
          EventBus.$emit('error', 'ERROR')
          this.clear()
        })
    }
  }
}
</script>

<style scoped>

.login {
  position: absolute;
  top: 50%;
  left: 50%;
  transform: translate(-50%, -50%);
}
.md-card {
  width: 320px;
  margin: 4px;
  display: inline-block;
  vertical-align: top;
  text-align: center;
}
</style>